#include "Arduino.h"
#include "Node.h"

class NodeUART : public Node {
	
 public:

	void publish(char*, char*);
    void publish(char*, bool);
	void publish(char*, int);
	void publish(char*, long);
	void publish(char*, double);
	void publish(char*, float);

  protected:
	
	NodeUART();
	
	virtual bool tx(char[])=0;
	virtual void rx()=0;
	
	char* encode(char*, char* = NULL, char* = NULL, char* = NULL);
	void  decode(char* );
	
	char* des(char*, bool = false);
	char* ack(char*, bool, char*);
	void respond(char*, char*, char*);
    void describe_parameter(char*, bool = false);
	void describe();

 };
	
	
