#include "Arduino.h"
#include "IPAddress.h"
#include "NodeUART.h"
#include "XBee.h"

class NodeZIGBEE : public NodeUART {

  public:
  
  	NodeZIGBEE();
	NodeZIGBEE(XBee&, ZBRxResponse&, ModemStatusResponse&);

	void set_client(XBee&, ZBRxResponse&, ModemStatusResponse&);
	void init(Stream&);
	void loop();
	
  private:
  
	char* _protocol = "ZIGBEE";
	
	XBee* _client;
	ZBRxResponse* _client_rx;
	ModemStatusResponse* _client_msr;
	
	bool tx(char[]);
	void rx();

};



